routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*Route::get('/', function () {
    return view('welcome');
});*/

Route::group(['namespace' => 'Web','as' => 'web.'], function () {

    //Home Page Routes
    Route::group(['as' => 'home.'], function () {

        Route::get('facebook', function () {
            return view('facebook');
        });
        Route::get('auth/facebook', 'FacebookController@redirectToFacebook')->name('facebook.login');
        Route::get('auth/facebook/callback', 'FacebookController@handleFacebookCallback');

        Route::get('/redirect', 'LoginController@redirectToProvider')->name('google.login');;
        Route::get('/callback', 'LoginController@handleProviderCallback');

        Route::get('/',     'HomeController@home')->name('index');

        Route::get('page/home',  'HomeController@home')->name('index');

        Route::get('/chits',             'HomeController@noteChits')->name('chits');

        Route::get('/about-us',      'HomeController@aboutUs')->name('about-us');

        Route::get('/contact-us',      'HomeController@contactUs')->name('contact-us');
        Route::post('/add-contact-us',      'HomeController@createContactUs')->name('add-contact');

        Route::get('/404',      'HomeController@notFound')->name('404');
        Route::get('/all-queries',      'HomeController@allQueries')->name('all-queries');
        Route::get('/my-queries',      'HomeController@myQueries')->name('my-queries');
        Route::get('/new-query',      'HomeController@newQuery')->name('new-query');
        Route::post('/add-query',      'HomeController@addQuery')->name('add-query');
        Route::get('/remove-query/{id}', 'HomeController@deleteQuery')->name('delete-query');

        Route::get('/category/{url}', 'HomeController@categoryNotes')->name('category');
    });

    //Notes without login
    Route::group(['as' => 'note.'], function () {
        Route::get('note/detail/{nNoteId?}',       'NoteController@noteDetailAction')->name('note-detail');

        Route::get('note/my-notes',        'NoteController@myNotesAction')->name('my-notes');
        Route::get('note/following-users-notes',  'NoteController@followingUsersNotesAction')->name('following-users-notes');
        Route::get('note/saved-notes',     'NoteController@savedNotesAction')->name('saved-notes');
        Route::get('search-notes/{keyword?}',     'NoteController@searchNoteAction')->name('search-notes');
        Route::post('note/get-note-view-data',     'NoteController@getNoteViewData')->name('note-view-data');
    });

    //USER
    Route::group(['as' => 'user.'], function () {
        Route::post('signup',               'UserController@SignUpAction')->name('signup');
        Route::post('login',                'UserController@SignInAction')->name('signin');
        Route::get('verification/{key?}',   'UserController@EmailVerificationAction')->name('verification');
        Route::post('forgot-password',      'UserController@ForgotPasswordAction')->name('forgot-password');
        Route::match(['GET','POST'],'reset-password/{key?}','UserController@ResetPasswordAction')->name('reset-password');

        Route::get('user/view-profile/{id}',     'UserController@userProfileForFollowAction')->name('user-view-profile');
        Route::match(['GET','POST'],'profile/{id}',  'UserController@userProfileAction')->name('profile');
        Route::match(['GET','POST'],'followers',  'UserController@getFollowersAction')->name('get-followers');
    });

    /**
     * After Login All routes
     */
    Route::group(['middleware' => 'webAuth'], function () {

        //User After Login
        Route::group(['as' => 'user.'], function () {

            Route::get('logout','UserController@LogoutAction')->name('logout');

            Route::match(['GET','POST'],'change-password',  'UserController@changePasswordAction')->name('change-password');
            Route::post('upload-profile-picture',           'UserController@uploadProfilePictureAction')->name('upload-profile-picture');

            Route::get('user/follow',                       'UserController@followAction')->name('follow');
            Route::get('user/add-area-of-interest',         'UserController@userAddAreaOfInterestAction')->name('add-area-of-interest');

            Route::get('user/update-area-of-interest',      'UserController@userUpdateAreaOfInterestAction')->name('update-area-of-interest');
            Route::get('user/get-notifications',            'UserController@getNotifications')->name('get-notifications');
            Route::post('user/update-notification-status',  'UserController@updateNotificationStatus')->name('update-notification-status');

        });

        //Note After Login
        Route::group(['as' => 'note.'], function () {

            Route::match(['GET','POST'],'note/add-note/{nNoteId?}', 'NoteController@addNoteAction')->name('add-note');

            Route::get('note/add-to-favourite','NoteController@addNoteToFavouriteAction')->name('add-to-favourite');
            Route::get('note/add-rating',      'NoteController@addRatingAction')->name('add-rating');

            Route::post('note/add-report',      'NoteController@addReportAction')->name('add-report');
            Route::get('note/download-note/{nNoteId}',      'NoteController@callDownloadZipAction')->name('download-note');

            Route::post('note/delete-note',      'NoteController@callDeleteNoteAction')->name('delete-note');
            Route::post('note/delete-note-attachment',      'NoteController@callDeleteNoteAttachmentAction')->name('delete-attachment');

            Route::get('note/download-action',      'NoteController@downloadFileFromS3')->name('download');

            Route::get('note/remove-from-folder','NoteController@removeNoteFromFolderAction')->name('remove-note-from-folder');
        });

        Route::group(['as' => 'bucket.'], function () {
            Route::get('user-buckets','BucketController@userBucket')->name('user-buckets');
            Route::get('get-user-buckets','BucketController@getUserBucket')->name('get-user-buckets');
            Route::post('bucket/create','BucketController@createBucket')->name('create-bucket');
            Route::post('bucket/delete','BucketController@deleteBucket')->name('delete-bucket');
            Route::post('bucket/save-note-to-user-bucket','BucketController@saveNoteToUserBucket')->name('save-to-user-bucket');
            Route::get('bucket/get-bucket-notes','BucketController@getBucketNotes')->name('get-bucket-notes');
            Route::get('get-user-buckets-list-move','BucketController@getUserBucketToMove')->name('get-user-buckets-list-move');
            Route::post('move-note-bucket','BucketController@moveNoteBucket')->name('move-note-bucket');
        });


        //Contribute Query suggestion
        Route::post('/add-query-suggestion', 'ContributionQueryCommentController@add')->name('contribution-query-comment-add');
        Route::post('/remove-query-suggestion', 'ContributionQueryCommentController@delete')->name('contribution-query-comment-remove');
        Route::get('/get-query-suggestion-comments', 'ContributionQueryCommentController@getCommentData')->name('get-query-suggestion-comments');
       

    }); //End of middleware check

});

/**
 * Admin Routes
 */
Route::get('/admin/login', 'Admin\AuthController@showLogin')->name('admin.show_login');
Route::post('/admin/login', 'Admin\AuthController@login')->name('admin.login');

Route::group(['namespace' => 'Admin','as' => 'admin.', 'prefix' => 'admin/', 'middleware' => 'auth:admin'], function () {
    Route::get('/', 'HomeController@index')->name('home');

    //Users
    Route::get('/users', 'UserController@index')->name('users');
    Route::post('/users/datatable', 'UserController@datatable')->name('users.datatable');
    Route::post('/users/verify-email', 'UserController@verifyEmail')->name('users.verify_email');
    Route::post('/users/change-status', 'UserController@changeStatus')->name('users.change_status');
   
    //Notes
    Route::get('/notes', 'NoteController@index')->name('notes');
    Route::post('/notes/datatable', 'NoteController@datatable')->name('notes.datatable');
    Route::post('/notes/delete', 'NoteController@delete')->name('notes.delete');
    Route::get('/reported-notes', 'NoteController@reportedNotes')->name('reported.notes');
    Route::post('/reported-notes-datatable', 'NoteController@reportedNoteDatatable')->name('reported.notes.datatable');
    Route::post('/get-reported-note-data', 'NoteController@getReportedNoteData')->name('reported.notes.get_data');

    //Category
    Route::get('/category', 'CategoryController@index')->name('category');
    Route::post('/category/datatable', 'CategoryController@datatable')->name('category.datatable');
    Route::post('/category/store', 'CategoryController@store')->name('category.store');
    Route::get('/category/edit/{id}', 'CategoryController@edit')->name('category.edit');
    Route::post('/category/update', 'CategoryController@update')->name('category.update');
    Route::post('/category/delete', 'CategoryController@destroy')->name('category.delete');
    Route::post('/category/check-name', 'CategoryController@checkName')->name('category.check_name');

    //Language
    Route::post('/language/datatable', 'LanguageController@datatable')->name('language.datatable');
    Route::resource('language', 'LanguageController')->only([
        'index', 'store', 'update', 'destroy'
    ]);;

    Route::get('/logout', 'AuthController@logout')->name('logout');
});

app/Models/Language.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Language extends Model
{
    const IN_ACTIVE = 0 , ACTIVE = 1;

    protected $fillable = [
        'name',
        'activated',
        'deleted'
    ];

    public function scopeActive($query)
    {
        return $query->where('languages.activated',self::ACTIVE);
    }

    public function notes(){
        return $this->hasMany(Note::class);
    }
}

app/Http/Controllers/Admin/LanguageController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Language;
use Illuminate\Http\Request;
use DataTables;
use Exception;

class LanguageController extends Controller
{
    public function index()
    {
        return view('web.admin.language.index');
    }

    public function datatable(){
        $data = Language::withCount('notes')
            ->get();

        return Datatables::of($data)
            ->addIndexColumn()
            ->addColumn('image', function ($data) {
                return '-';
            })
            ->addColumn('action', function ($data) {
                $str = '';
                if($data->deleted == 0){
                    $str .= '<button class="btn btn-info btn-sm mr-2 editLanguage" data-id="'.$data->id.'" data-name="'.$data->name.'"><i class="fa-solid fas fa-edit"></i></button>';
                    $str .= '<button class="btn btn-danger btn-sm mr-2 deleteLanguage" data-id="'.$data->id.'"><i class="fa-solid fas fa-trash"></i></button>';
                }
                return $str;
            })
            ->make(true);

    }

    public function store(Request $request)
    {
        $language = Language::where(['name'=>$request->language])->active()->latest()->first();
        if(! $language){
            Language::create([
                'name' => $request->language,
            ]);

            return response()->json([
                'status' => 'Success',
                'message' => 'Language Created Successfully.'
            ], 200);
        }
        return response()->json([
            'status' => 'Error',
            'message' => 'Language Already Exists'
        ],200);
    }

    public function update(Request $request, $id)
    {
        $language = Language::where(['name'=>$request->language])
            ->where('id','!=',$id)
            ->active()
            ->latest()
            ->first();

        if(! $language){
            $language = Language::where('id',$id)->update(['name'=>$request->language]);
            return response()->json([
                'status' => 'Success',
                'message' => 'Language Updated Successfully.'
            ], 200);
        }
        return response()->json([
            'status' => 'Error',
            'message' => 'Language Name Already Exists'
        ],200);
    }

    public function destroy($id)
    {
        try{
            $data = Language::find($id);
            $data->deleted = 1;
            $data->save();

            return response()->json('Language Deleted Successfully.', 200);
        }catch(Exception $e){
            return response()->json('Something went wrong', 500);
        }
    }
}

resources/views/web/admin/language/index.blade.php
@extends('web.admin.layout')
@section('title')
    Language
@endsection
@section('page_title')
    Language
@endsection
@section('css')
<style>
div.dt-buttons {
    float: right;
}
</style>
@endsection
@section('content')
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <table id="language-datatable" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Id</th>
                            <th>name</th>
                            <th>No of Notes</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
<div class="modal fade" id="addLanguageModel" tabindex="-1" role="dialog" aria-labelledby="addLanguageModelLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <form id="form">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="modal-title" id="addLanguageModelLabel"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-md-12 form-group">
                            <label>Name:</label>
                            <input type="text" name="language_name" id="language_name" class="form-control">
                            <span id="language_name-error" style="color:red;"></span>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" id="btnSave"></button>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection
@section('js')
<script>
    var dt = $('#language-datatable').DataTable({
        responsive: true,
        processing: true,
        serverSide: true,
        ajax: {
            url:'{{route("admin.language.datatable")}}',
            type:'POST',
        },
        columns: [
            {data: 'DT_RowIndex'},
            {data: 'name'},
            {data: 'notes_count'},
            {data: 'action'},
        ],
        dom: 'Bfrtip',
        buttons: [
            {
                text: 'Add Language',
                className : 'btn-sm ml-2 mr-2 text-right',
                action: function ( e, dt, node, config ) {
                    showAdd();
                }
            }
        ]
    });
    
    function showAdd(){
        clearForm();
        $('#addLanguageModelLabel').text('Add Language');
        $('#addLanguageModel').modal('show');
        $('#btnSave').text('Add');
        $('#btnSave').addClass('saveLanguage');
    }
    
    $(document).on('click', '.saveLanguage', function(){
        language = $('#language_name').val();

        if(language != ''){
            $.ajax({
                type:'POST',
                url: '{{route('admin.language.store')}}',
                data:{
                    language:language,
                },
                success:function(data){
                    if(data.status == "Error"){
                        $('#language_name-error').text(data.message);
                    }else{
                        toastr.success(data.message);
                        clearForm();
                        dt.ajax.reload();
                    }
                },
                error: function(data){
                    console.log(data);
                }
            });
        }else{
            $('#language_name-error').text("This field is required.");
            $('#language_name').focus();
        }
    });

    function clearForm(){
        $('#language_name').val('');
        $('#addLanguageModel').modal('hide');
        $('#language_name-error').text('');
        $('#btnSave').text('');
        $('#btnSave').removeClass('saveLanguage');
        $('#btnSave').removeClass('updateLanguage');
        $('#btnSave').removeAttr('data-id');
    }
    $(document).ready(function(){
        $("form").submit(function(e){
            e.preventDefault();
        });
    });

    $(document).on('click', '.editLanguage',function(){
        clearForm();
        $('#addLanguageModelLabel').text('Edit Language');
        data_id = $(this).data('id');
        data_name = $(this).data('name');
        $('#btnSave').text('Update');
        $('#btnSave').attr('data-id', data_id);
        $('#btnSave').addClass('updateLanguage');
        $('#language_name').val(data_name);
        $('#addLanguageModel').modal('show');
    });
    $(document).on('click', '.updateLanguage',function(){
        language = $('#language_name').val();
        data_id = $(this).data('id');

        let url = "{{ route('admin.language.update', ':id') }}";
        url = url.replace(':id', data_id);        
        if(language != ''){
            $.ajax({
                type:'PUT',
                url: url,
                data:{
                    language:language,
                },
                success:function(data){
                    if(data.status == "Error"){
                        $('#language_name-error').text(data.message);
                    }else{
                        toastr.success(data.message);
                        clearForm();
                        dt.ajax.reload();
                    }
                },
                error: function(data){
                    console.log(data);
                }
            });
        }else{
            $('#language_name-error').text("This field is required.");
            $('#language_name').focus();
        }
    });
    $(document).on('click', '.deleteLanguage',function(){
        var data_id = $(this).data('id');
        let url = "{{ route('admin.language.destroy', ':id') }}";
        url = url.replace(':id', data_id);

        $.ajax({
            type:'DELETE',
            url: url,
            success:function(data){
                toastr.success(data);
                dt.ajax.reload();
            },
            error: function(data){
                toastr.warning(data);
            }
        });
    });
    </script>
@endsection